## pegasus-wms 4.4.0+dfsg

=== requirements.txt ===
requests
mock

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/boto.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/boto.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== doc/build/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = output

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest dist-html site-mako gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  gettext    to make PO message catalogs"
	@echo "  dist-html  same as html, but places files in /doc"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html -A mako_layout=html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

dist-html:
	$(SPHINXBUILD) -b html -A mako_layout=html $(ALLSPHINXOPTS) ..
	@echo
	@echo "Build finished.  The HTML pages are in ../."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/SQLAlchemy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/SQLAlchemy.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/SQLAlchemy"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/SQLAlchemy"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	cp texinputs/* $(BUILDDIR)/latex/
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	cp texinputs/* $(BUILDDIR)/latex/
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) .
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== doc/docbook/Makefile ===
PEGASUS_HOME=$(shell cd ../.. && pwd)
VERSION=$(shell ../../release-tools/getversion)

XML  = about.xml
XML += creating_workflows.xml
XML += example_workflows.xml
XML += execution_environments.xml
XML += funding_citing_usage_stats.xml
XML += glossary.xml
XML += installation.xml
XML += monitoring_debugging_stats.xml
XML += pegasus-book.xml
XML += reference.xml
XML += reference_api.xml
XML += reference_command_lines.xml
XML += reference_hierarchical_workflow.xml
XML += reference_job_clustering.xml
XML += reference_monitoring.xml
XML += reference_notifications.xml
XML += reference_profiles.xml
XML += reference_replica_selection.xml
XML += reference_transfers.xml
XML += running_workflows.xml
XML += submit_directory.xml
XML += tutorial.xml
XML += tutorial_vm.xml
XML += useful_tips.xml

# Generated stuff
XML += title.xml basic_properties.xml reference_properties.xml

# Generated manpages
MANPAGES=$(shell ls ../manpages | grep txt)
XMLMANPAGES=$(addprefix manpage.,$(MANPAGES:.txt=.xml))
TXTMANPAGES=$(addprefix ../manpages/,$(MANPAGES))
XMLMANPAGES += manpage.manpages.xml
XML += $(XMLMANPAGES)

SAMPLEPROPS=../../libexec/docbook-sample-props
PROP2DOC=env PEGASUS_HOME=$(PEGASUS_HOME) $(SAMPLEPROPS)
BASICPROPS=../../etc/basic.properties
ADVANCEDPROPS=../../etc/advanced.properties

ifndef ${prefix}
prefix = $(PEGASUS_HOME)/share/pegasus/doc
endif

TARGETS = html pegasus-user-guide.pdf

all: $(TARGETS)

$(XMLMANPAGES): $(TXTMANPAGES)
	make -C ../manpages install-docbook

title.xml: ../../build.properties
	echo "<title>Pegasus $(VERSION) User Guide</title>" > title.xml

basic_properties.xml: $(BASICPROPS) $(SAMPLEPROPS)
	$(PROP2DOC) $(BASICPROPS) > basic_properties.xml

reference_properties.xml: $(ADVANCEDPROPS) $(SAMPLEPROPS)
	$(PROP2DOC) $(ADVANCEDPROPS) > reference_properties.xml

html: $(XML) pegasus-php-style.xsl
	mkdir -p ./html/images
	xsltproc --noout --stringparam base.dir ./html/ --xinclude pegasus-php-style.xsl pegasus-book.xml
	cp images/*.png images/*.jpg ./html/images/
	touch html

pegasus-user-guide.fo: $(XML) pegasus-pdf-style.xsl
	xsltproc --xinclude pegasus-pdf-style.xsl pegasus-book.xml > pegasus-user-guide.fo

pegasus-user-guide.pdf: pegasus-user-guide.fo
	fop pegasus-user-guide.fo -pdf pegasus-user-guide.pdf 2>&1 \
        | grep -v "The following feature isn't implemented by Apache FOP, yet: table-layout=\"auto\"" \
        | grep -v "function may only be used when fo:table has table-layout=\"fixed\""

install: $(TARGETS)
	mkdir -p ${prefix}
	cp -R html ${prefix}/
	cp pegasus-user-guide.pdf ${prefix}/

clean:
	rm -rf html pegasus-user-guide.pdf pegasus-user-guide.fo ./*~ title.xml basic_properties.xml reference_properties.xml manpage.*.xml

=== doc/manpages/Makefile ===
ifndef ${prefix}
prefix = ../..
endif

ifndef ${datadir}
datadir = $(prefix)/share
endif

VERSION = $(shell ../../release-tools/getversion)

ASCIIDOC = asciidoc -a manversion=$(VERSION) -a mansource="Pegasus" -a manmanual="Pegasus Manual" -d manpage -b docbook
XSLTPROC = xsltproc -xinclude
FOP = fop

DOCBOOK2FO = $(XSLTPROC) docbook-pdf.xsl
DOCBOOK2MAN = $(XSLTPROC) docbook-man.xsl
DOCBOOK2HTML = $(XSLTPROC) docbook-html.xsl

TXTFILES = $(shell ls *.txt)
MANPAGES = $(TXTFILES:.txt=.1)
XMLMANPAGES = $(TXTFILES:.txt=.xml)
PDFMANPAGES = $(TXTFILES:.txt=.pdf)
HTMLMANPAGES = $(TXTFILES:.txt=.html)


.PHONY: manpages pdfmanpages htmlmanpages

.PRECIOUS: %.xml

all: manpages

manpages: $(MANPAGES)
pdfmanpages: $(PDFMANPAGES)
htmlmanpages: $(HTMLMANPAGES)

manpages.fo : manpages.xml $(XMLMANPAGES)
manpages.pdf : manpages.fo
manpages.html : manpages.xml $(XMLMANPAGES)

%.html : %.xml
	$(DOCBOOK2HTML) $< > $@

%.1 : %.xml
	$(DOCBOOK2MAN) $<

%.pdf : %.fo
	$(FOP) $< $@

%.fo : %.xml
	$(DOCBOOK2FO) $< > $@

%.xml : %.txt
	$(ASCIIDOC) -o $@ $<
	BASENAME=`echo $< | sed 's/.txt//'`; \
	sed -i.bak -E "s/id=\"(_[^\"]+)\"/id=\"$$BASENAME\1\"/" $@ ; \
	sed -i.bak -E "s/<refentry lang.*/<refentry lang='en' id='cli-$$BASENAME'>/" $@ ; \
	rm $@.bak

clean:
	rm -f pegasus-*.xml *.fo *.pdf *.1 *.html

install: manpages
	mkdir -p $(datadir)/man/man1
	for MPAGE in $(MANPAGES); do \
		cp $$MPAGE $(datadir)/man/man1/; \
	done

install-docbook: $(XMLMANPAGES)
	for XML in `ls *.xml`; do \
		cp $$XML ../docbook/manpage.$$XML; \
	done

=== src/externals/Makefile ===
ifndef ${prefix}
prefix = $(PEGASUS_HOME)
endif

ifndef ${libdir}
libdir = ${prefix}/lib
endif

PySQLite=pysqlite-2.6.0
BOTO=boto-2.5.2
SQLAlchemy=SQLAlchemy-0.7.6
need_pysqlite2=$(shell if python -V 2>&1 | grep -qE 'ython 2\.[3-4]'; then echo 1; else echo 0; fi)

all: ${libdir}/python/pysqlite2 ${libdir}/python/sqlalchemy ${libdir}/python/boto 

${libdir}/python/pysqlite2:
ifeq ($(need_pysqlite2), 1)
	@rm -rf $(PySQLite)
	tar xzf $(PySQLite).tar.gz
	(cd $(PySQLite) && \
	    python setup.py build_static && \
	    cp -R build/lib*/pysqlite2 ${libdir}/python/ \
	)
	@rm -rf $(PySQLite)
else
	mkdir -p ${libdir}/python/pysqlite2
endif

${libdir}/python/sqlalchemy:
	@rm -rf $(SQLAlchemy)
	tar xzf $(SQLAlchemy).tar.gz
	(cd $(SQLAlchemy) && \
	  python setup.py build && \
	  cp -R build/lib*/sqlalchemy ${libdir}/python/ \
	)
	@rm -rf $(SQLAlchemy)

${libdir}/python/boto:
	@rm -rf $(BOTO)
	tar xzf $(BOTO).tar.gz
	(cd $(BOTO) && \
	  python setup.py build && \
	  rm -rf ${prefix}/lib/python/boto && \
	  cp -R build/lib*/boto ${libdir}/python/ \
	)
	@rm -rf $(BOTO)

clean:
	rm -rf touch.pysqlite $(PySQLite)
	rm -rf touch.sqlalchemy $(SQLAlchemy)
	rm -rf touch.boto $(BOTO) .boto*

=== src/tools/Makefile ===
#
# build all C/C++ sources 
#
# $Id$
#
TARGET	= pegasus-cluster pegasus-invoke pegasus-keg pegasus-kickstart pegasus-mpi-cluster
CONDOR_VERSION	= $(shell condor_version | awk '{ print $2; exit }')
MARCH   = $(shell uname -m | tr '[A-Z]' '[a-z]')

ifndef ${prefix}
prefix = $(PEGASUS_HOME)
endif

.ONESHELL:
all clean distclean install:
	for i in $(TARGET); do \
	    if [ -d $$i ]; then \
		$(MAKE) -C $$i $@ || exit 1; \
	    fi; \
	done

=== contrib/wfprof/old/Makefile ===
CC = gcc
CFLAGS = -Wall
TARGET = pprof

all: $(TARGET)

pprof: pprof.o

clean:
	rm -f *.o $(TARGET)

=== doc/schemas/monitord/Makefile ===
# Makefile for monitoring event Yang schemas
#
# Prerequisites:
# 	pyang - http://code.google.com/p/pyang/
#

# Schema directory is by default relative to
# this directory
schemadir := ../../../share/pegasus/schema

# Python Yang (pyang) setup
# Yang should be installed by user
#PYANG_HOME := $(HOME)/local
#yang2dsdl := PYANG_XSLT_DIR=$(PYANG_HOME)/share/yang/xslt	\
	     PYANG_RNG_LIBDIR=$(PYANG_HOME)/share/yang/schema \
	     yang2dsdl

yang2dsdl := yang2dsdl

# Pick a schema version
schema_ver=2011-05-04

default: validate

# Transform BP log to XML
transform: output-file.xml

%.xml: %.bp
	nl_load -v xml pretty=true netconf=true < output-file.bp > output-file.xml

# Validate XML
validate: transform
	$(yang2dsdl) -v output-file.xml $(schemadir)/stampede-schema.yang 

# Clean up
clean:
	/bin/rm -f *.dsrl *.rng *.sch *.xml

=== src/tools/pegasus-cluster/Makefile ===
#
# Makefile
# $Id$
#
INSTALL	= install
RM	= rm -f
CC	= gcc
CXX	= g++
SYSTEM  = $(shell uname -s | tr '[a-z]' '[A-Z]' | tr -d '_ -/')
VERSION = $(shell uname -r)
MARCH	= $(shell uname -m | tr '[A-Z]' '[a-z]')
MAJOR   = $(firstword $(subst ., ,$(VERSION)))
LOADLIBES = -lm

ifndef ${prefix}
prefix	= $(PEGASUS_HOME)
endif

ifndef ${datadir}
datadir = $(prefix)/share 
endif

ifeq (SUNOS,${SYSTEM})
ifeq (5,${MAJOR})
CC	= cc
CXX	= CC
V7FLAGS	= -xtarget=generic
V9FLAGS	= -xtarget=ultra -xarch=v9
CFLAGS	= -dalign -ftrap=%none -fsimple -xlibmil $(EXTRACFLAGS)
CFLAGS := -DSOLARIS $(CFLAGS) -xO4 -D__EXTENSIONS__=1
LDFLAGS	+= $(EXTRACFLAGS)
INSTALL	= /usr/ucb/install
LOADLIBES += -lnsl
else
# old Solaris 1 not supported
endif
endif

ifeq (AIX,${SYSTEM})
CXX	= xlC
CC	= xlc
endif

ifeq (LINUX,${SYSTEM})
CFLAGS	:= -Wall -O2 -ggdb
ifeq (ia64,${MARCH})
#
# Linux IA64
#
CFLAGS	+= -DMARCH_IA64=1
else
ifeq (x86_64,${MARCH})
#
# Linux AMD64
#
CFLAGS	+= -m64
else
ifeq (armv7l, ${MARCH})
# nothing to do
else
#
# Linux IA32
#
CFLAGS	+= -march=i686
# LDFLAGS	+= -static
endif
endif
endif
endif

#
# === [3] ======================================================= rules section
# There is no need to change things below this line.
CFLAGS	+= -D${SYSTEM} -DMAJOR=${MAJOR}
LD	= $(CC) -D_FILE_OFFSET_BITS=64
CC	+= -D_FILE_OFFSET_BITS=64
CFLAGS	+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE

%.html : %.1 ;
	$(NROFF) $(HTML) $< > $@
%.ps : %.1 ;
	$(NROFF) $< > $@
%.txt : %.1 ;
	$(NROFF) $(TEXT) $< > $@
%.o : %.c
	$(CC) $(CFLAGS) $< -c -o $@

all: pegasus-cluster

job.o: job.c job.h
mysystem.o: mysystem.c tools.h report.h mysystem.h
parser.o: parser.c parser.h tools.h
report.o: report.c tools.h report.h
pegasus-cluster.o: pegasus-cluster.c tools.h parser.h report.h mysystem.h \
  job.h statinfo.h
statinfo.o: statinfo.c statinfo.h
tools.o: tools.c tools.h
try-cpus.o: try-cpus.c

pegasus-cluster: pegasus-cluster.o tools.o parser.o report.o mysystem.o \
	job.o statinfo.o 
	$(LD) $(LDFLAGS) $^ -o $@ $(LOADLIBES)

try-cpus: try-cpus.o
	$(LD) $(LDFLAGS) $^ -o $@ $(LOADLIBES)

install: pegasus-cluster
	$(INSTALL) -m 0755 $^ $(prefix)/bin

check:	pegasus-cluster
	bash check.sh

clean:
	$(RM) *.o core core.* check.?

distclean: clean
	$(RM) pegasus-cluster try-cpus

=== src/tools/pegasus-invoke/Makefile ===
#
# Makefile 
#
INSTALL	= install	# use /usr/ucb/install on Solaris
RM	= rm -f
CC	= gcc
LD	= $(CC)
SYSTEM  = $(shell uname -s | tr '[a-z]' '[A-Z]' | tr -d '_ -/')
VERSION = $(shell uname -r)
MARCH   = $(shell uname -m | tr '[A-Z]' '[a-z]')
MAJOR   = $(firstword $(subst ., ,$(VERSION)))
MINOR   = $(strip $(word 2,$(subst ., ,$(VERSION))))

ifndef ${prefix}
prefix = $(PEGASUS_HOME)
endif

ifndef ${datadir}
datadir = $(prefix)/share 
endif

ifeq (SUNOS,${SYSTEM})
ifeq (5,${MAJOR})
# use these for the SUN CC compiler
CC	= cc
LD	= $(CC)
## SPARCv7
V7FLAGS	= -xtarget=generic
V9FLAGS	= -xtarget=ultra -xarch=v9
CFLAGV7FLAGS = -xtarget=generic
V9FLAGS = -xtarget=ultra -xarch=v9
CFLAGS  = -dalign -ftrap=%none -fsimple -xlibmil $(EXTRACFLAGS)
#EXTRACFLAGS = $(V7FLAGS)
CFLAGS := -DSOLARIS $(CFLAGS) -xO4 -D__EXTENSIONS__=1
LOADLIBES += -lnsl -lsocket
INSTALL = /usr/ucb/install
else
# old Solaris 1 not supported!
endif
endif

ifeq (IRIX64,${SYSTEM})
# The regular 64bit Irix stuff is just too slow, use n32!
SYSTEM        := IRIX
endif

ifeq (IRIX,${SYSTEM})
CC      = cc -n32 -mips3 -r4000
LD      = $(CC)
OPT_NORM = -O3 -IPA -LNO:opt=1
endif

ifeq (AIX,${SYSTEM})
CXX     = xlC_r
CC      = xlc_r
endif

ifeq (LINUX,${SYSTEM})
ifeq (ia64,${MARCH})
CFLAGS  = -Wall -O2 -ggdb
else
ifeq (x86_64,${MARCH})
CFLAGS  = -Wall -O2 -ggdb -m64
else
ifeq (armv7l,${MARCH})
CFLAGS	= -Wall -02 -ggdb
else
CFLAGS  = -Wall -O2 -march=i686 -ggdb
#EXTRA_LDFLAGS += -static
endif
endif
endif
#CFLAGS += -D__USE_POSIX=199309
endif

#
# === [3] ======================================================= rules section
# There is no need to change things below this line.
CFLAGS += -D${SYSTEM} -DMAJOR=${MAJOR} -DMINOR=${MINOR}
#CFLAGS += -D_POSIX_C_SOURCE=199506 -D__USE_XOPEN_EXTENDED

%.o : %.c
	$(CC) $(CFLAGS) $< -c -o $@

all : pegasus-invoke

pegasus-invoke: pegasus-invoke.o main.o
	$(LD) $(LDFLAGS) $(CFLAGS) $(OBJS) $^ -o $@ $(LOADLIBES)

pegasus-invoke.o: pegasus-invoke.c pegasus-invoke.h
main.o: main.c

install: pegasus-invoke
	$(INSTALL) -m 0755 pegasus-invoke $(prefix)/bin

clean:
	$(RM) *.o core core.*

distclean: clean
	$(RM) pegasus-invoke

=== src/tools/pegasus-kickstart/Makefile ===
INSTALL = install
RM = rm -f
CC = gcc
CFLAGS = -O
LD = $(CC)
LOADLIBES = -lm
SYSTEM = $(shell uname -s | tr '[a-z]' '[A-Z]' | tr -d '_ -/')
VERSION = $(shell uname -r)
MARCH = $(shell uname -m | tr '[A-Z]' '[a-z]')
MAJOR = $(firstword $(subst ., ,$(VERSION)))
MINOR = $(strip $(word 2,$(subst ., ,$(VERSION))))
EXTRA_OBJ = machine/basic.o
SOCKIO = $(shell /bin/ls /usr/include/sys/sockio.h 2>/dev/null)
LFS_CFLAGS = -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE 
LFS_LDFLAGS =

ifndef ${prefix}
prefix = $(PEGASUS_HOME)
endif

ifndef ${datadir}
datadir = $(prefix)/share
endif

ifeq (DARWIN,${SYSTEM})
CFLAGS += -Wall -DMUST_USE_SELECT_NOT_POLL=1 -DHAS_REALPATH_EXT=1 -ggdb
LOADLIBES += -ggdb
EXTRA_OBJ += machine/darwin.o
endif

ifeq (LINUX,${SYSTEM})
ifeq (ia64,${MARCH})
# old Intel-only IA64 architecture
CFLAGS = -Wall -O2 -ggdb
else
ifeq (x86_64,${MARCH})
# new Intel/AMD 64bit architecture
CFLAGS = -Wall -O2 -ggdb -m64
else
ifeq (i686,${MARCH})
# regular 32bit x86 architecture
CFLAGS = -Wall -O2 -march=i686 -ggdb
else
# UNKNOWN ARCHITECTURE -- MAKE NO ASSUMPTIONS
CFLAGS = -Wall -O2 -ggdb
endif
endif
endif
LFS_CFLAGS = $(shell getconf LFS_CFLAGS 2>>/dev/null)
LFS_LDFLAGS = $(shell getconf LFS_LDFLAGS 2>>/dev/null)
EXTRA_OBJ += machine/linux.o
CFLAGS += -DHAS_REALPATH_EXT=1
endif

CFLAGS += -D${SYSTEM} -DMAJOR=${MAJOR} -DWITH_NEW_ARGS=1
ifneq (,${SOCKIO})
CFLAGS += -DHAS_SYS_SOCKIO=1
endif
CFLAGS += -DUSE_PARSE=1

# add large file support
ifneq (,${LFS_CFLAGS})
NOLFS_CFLAGS := $(CFLAGS)
CFLAGS += $(LFS_CFLAGS)
endif
ifneq (,${LFS_LDFLAGS})
LDFLAGS += $(LFS_LDFLAGS)
endif

.PHONY: test

%.o : %.c
	$(CC) $(CFLAGS) $< -c -o $@

all : pegasus-kickstart

pegasus-kickstart: debug.o getif.o rwio.o tools.o useinfo.o mynss.o statinfo.o jobinfo.o limitinfo.o $(EXTRA_OBJ) machine.o appinfo.o parse.o mysystem.o mylist.o invoke.o pegasus-kickstart.o procinfo.o
	$(LD) $(EXTRA_LDFLAGS) $(CFLAGS) $^ -o $@ $(LOADLIBES)
show-if: show-if.o getif.o debug.o rwio.o
	$(LD) $(EXTRA_LDFLAGS) $(CFLAGS) $^ -o $@ $(LOADLIBES)
try-parse: try-parse.o parse.o debug.o rwio.o
	$(LD) $(EXTRA_LDFLAGS) $(CFLAGS) $^ -o $@ $(LOADLIBES)

appinfo.o: appinfo.c getif.h rwio.h debug.h tools.h useinfo.h machine.h \
  jobinfo.h statinfo.h appinfo.h limitinfo.h mynss.h
debug.o: debug.c debug.h rwio.h
fail.o: fail.c
getif.o: getif.c debug.h getif.h rwio.h
invoke.o: invoke.c invoke.h
jobinfo.o: jobinfo.c getif.h debug.h tools.h useinfo.h jobinfo.h \
  statinfo.h parse.h procinfo.h
pegasus-kickstart.o: pegasus-kickstart.c rwio.h debug.h appinfo.h \
  statinfo.h jobinfo.h limitinfo.h machine.h mysystem.h mylist.h \
  invoke.h tools.h version.h ptrace.h
limitinfo.o: limitinfo.c debug.h tools.h limitinfo.h
machine.o: machine.c machine.h machine/basic.h debug.h
mylist.o: mylist.c mylist.h
mynss.o: mynss.c mynss.h
mysystem.o: mysystem.c debug.h tools.h appinfo.h statinfo.h jobinfo.h \
  limitinfo.h machine.h mysystem.h mysignal.h procinfo.h
parse.o: parse.c debug.h parse.h
procinfo.o: procinfo.c procinfo.h ptrace.h tools.h
rwio.o: rwio.c rwio.h
show-if.o: show-if.c getif.h
statinfo.o: statinfo.c mynss.h debug.h statinfo.h tools.h
test-ascii.o: test-ascii.c
test-post.o: test-post.c
test-pre.o: test-pre.c
tools.o: tools.c tools.h
try-parse.o: try-parse.c parse.h rwio.h
useinfo.o: useinfo.c tools.h useinfo.h
zio.o: zio.c zio.h

machine/basic.o: machine/basic.c machine/basic.h machine/../tools.h
machine/linux.o: machine/linux.c machine/basic.c machine/linux.h \
  machine/../tools.h
machine/darwin.o: machine/darwin.c machine/basic.c machine/darwin.h \
  machine/../tools.h

version.h:
	$(CURDIR)/../../../release-tools/getversion --header > $(CURDIR)/version.h

install: pegasus-kickstart
	$(INSTALL) -m 0755 pegasus-kickstart $(prefix)/bin

clean:
	$(RM) *.o machine/*.o core core.* version.h

distclean: clean
	$(RM) pegasus-kickstart fail test-post test-pre test-ascii show-if

test: pegasus-kickstart
	cd $(CURDIR)/test && ./test.sh

=== debian/changelog ===
pegasus-wms (4.4.0+dfsg-8) unstable; urgency=medium

  * QA upload.
  * Switch from libmysql-java to libmariadb-java.
  * Declare compliance with Debian Policy 4.2.1.
  * Fix Lintian error wrong-path-for-interpreter.

 -- Markus Koschany <apo@debian.org>  Fri, 09 Nov 2018 14:12:40 +0100

pegasus-wms (4.4.0+dfsg-7) unstable; urgency=medium

  * QA upload.
  * Set JAVA_HOME to point to default-jdk.
    Thanks to Chris West for the report. (Closes: #875778)
  * Use compat level 11.
  * Use secure homepage address.
  * Declare compliance with Debian Policy 4.1.3.

 -- Markus Koschany <apo@debian.org>  Wed, 24 Jan 2018 21:04:00 +0100

pegasus-wms (4.4.0+dfsg-6) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS when building Arch:all only (closes: #845125).

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 07 Dec 2016 08:34:57 +0100

pegasus-wms (4.4.0+dfsg-5) unstable; urgency=medium

  * QA upload.
  * Set the maintainer to the QA team.
  * Depend on default-jdk / default-jre (closes: #814170).
  * Fix a bashism in pbs_local_submit_attributes.sh (closes: #772348).
  * Drop all -m64, fixes FTBFS on x32.
  * Force javadoc encoding to UTF-8.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 12 Feb 2016 12:34:12 +0100

pegasus-wms (4.4.0+dfsg-4) unstable; urgency=low

  * Worked with upstream on enabling the hardening flags to
    propagate. The fix is shipped as a quilt patch in this
    upload.
  * Added another patch for GNU/kFreeBSD.

 -- Mats Rynge <mats@rynge.net>  Wed, 30 Jul 2014 11:30:10 -0700

pegasus-wms (4.4.0+dfsg-3) unstable; urgency=low

  * Added a patch for GNU/kFreeBSD

 -- Mats Rynge <mats@rynge.net>  Tue, 29 Jul 2014 15:38:57 -0700

pegasus-wms (4.4.0+dfsg-2) unstable; urgency=low

  * Added missing dependencies to control
  * Disabled the build of pegasus-mpi-cluster

 -- Mats Rynge <mats@rynge.net>  Tue, 29 Jul 2014 11:33:00 -0700

pegasus-wms (4.4.0+dfsg-1) unstable; urgency=low

  * Updated to upstream version 4.4.0
  * Added a patch to change the default worker package to Debian

 -- Mats Rynge <mats@rynge.net>  Mon, 28 Jul 2014 16:21:00 -0700

=== debian/control ===
Source: pegasus-wms
Section: science
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 11),
               default-jdk,
               ant,
               docbook-xsl,
               docbook-xml,
               asciidoc,
               xsltproc,
               fop,
               perl,
               python,
               python-dev,
               libcommons-logging-java,
               libcommons-pool-java,
               libgetopt-java,
               liblog4j1.2-java,
               libmariadb-java,
               libxml-commons-resolver1.1-java,
               libxerces2-java,
               libxmlrpc3-common-java,
               libjglobus-gss-java,
               libjglobus-jsse-java,
               libjglobus-ssl-proxies-java,
               libjglobus-gridftp-java,
               libjglobus-gram-java,
               libgoogle-gson-java
Standards-Version: 4.2.1
Homepage: https://pegasus.isi.edu

Package: pegasus-wms
Architecture: any
Depends: default-jre,
         perl,
         python,
         python-boto,
         python-sqlalchemy,
         libcommons-logging-java,
         libcommons-pool-java,
         libgetopt-java,
         liblog4j1.2-java,
         libmariadb-java,
         libxml-commons-resolver1.1-java,
         libxerces2-java,
         libxmlrpc3-common-java,
         libjglobus-gss-java,
         libjglobus-jsse-java,
         libjglobus-ssl-proxies-java,
         libjglobus-gridftp-java,
         libjglobus-gram-java,
         libgoogle-gson-java,
         ${shlibs:Depends}, ${misc:Depends}
Recommends: htcondor
Suggests: pegasus-wms-doc
Description: Scientific workflow management system for HTCondor
 The Pegasus project encompasses a set of technologies the help
 workflow-based applications execute in a number of different
 environments including desktops, campus clusters, grids, and now
 clouds. Scientific workflows allow users to easily express
 multi-step computations, for example retrieve data from a
 database, reformat the data, and run an analysis. Once an
 application is formalized as a workflow the Pegasus Workflow
 Management Service can map it onto available compute resources
 and execute the steps in appropriate order.

Package: pegasus-wms-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: pegasus-wms
Description: Scientific workflow management system for HTCondor - documentation files
 The Pegasus project encompasses a set of technologies the help
 workflow-based applications execute in a number of different
 environments including desktops, campus clusters, grids, and now
 clouds. Scientific workflows allow users to easily express
 multi-step computations, for example retrieve data from a
 database, reformat the data, and run an analysis. Once an
 application is formalized as a workflow the Pegasus Workflow
 Management Service can map it onto available compute resources
 and execute the steps in appropriate order.
 .
 This package contains the user documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export JAVA_HOME=/usr/lib/jvm/default-java

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

JARS := commons-logging.jar commons-pool.jar gnu-getopt.jar log4j-1.2.jar mariadb-java-client.jar xml-resolver.jar xercesImpl.jar xmlParserAPIs.jar xmlrpc-common.jar jglobus-ssl-proxies.jar jglobus-gss.jar jglobus-gridftp.jar jglobus-gram.jar gson.jar


build: build-arch build-indep


build-arch: build-arch-stamp


build-indep: build-indep-stamp


build-arch-stamp:
	dh_testdir

	# during build we need symlinks to system provided jars
	(cd share/pegasus/java && \
	 rm -f *.jar && \
	 for JAR in $(JARS); do \
	     ln -s /usr/share/java/$$JAR ; \
	 done \
	)

	ant dist doc-manpages

	rm -f dist/*.tar.gz
	mv dist/pegasus-* dist/pegasus

	touch build-arch-stamp


build-indep-stamp:
	dh_testdir

	# during build we need symlinks to system provided jars
	(cd share/pegasus/java && \
	 rm -f *.jar && \
	 for JAR in $(JARS); do \
	     ln -s /usr/share/java/$$JAR ; \
	 done \
	)

	# build documentation to get updated PDFs
	ant doc

	rm -f dist/*.tar.gz
	mv dist/pegasus-* dist/doc

	touch build-indep-stamp


# Build architecture-independent files here.
binary-indep: build-indep

	dh_testdir -i
	dh_testroot -i
	dh_prep -i
	dh_installdirs -i

	# move documentation to the -doc package
	mkdir -p debian/pegasus-wms-doc/usr/share/doc/pegasus-wms-doc
	cp -r dist/doc/share/doc/pegasus/* debian/pegasus-wms-doc/usr/share/doc/pegasus-wms-doc/
	rm -f debian/pegasus-wms-doc/usr/share/doc/pegasus-wms-doc/html/*.php

	dh_installchangelogs -i
	dh_installdocs -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
binary-arch: build-arch
	dh_testdir -a
	dh_testroot -a
	dh_prep -a
	dh_installdirs -a

	# /etc/pegasus
	mkdir -p debian/pegasus-wms/etc/pegasus
	cp -a dist/pegasus/etc/* debian/pegasus-wms/etc/pegasus/

	# /usr/bin
	mkdir -p debian/pegasus-wms/usr
	cp -a dist/pegasus/bin debian/pegasus-wms/usr/
	strip debian/pegasus-wms/usr/bin/pegasus-cluster
	strip debian/pegasus-wms/usr/bin/pegasus-invoke
	strip debian/pegasus-wms/usr/bin/pegasus-keg
	strip debian/pegasus-wms/usr/bin/pegasus-kickstart

	# /usr/share/
	mkdir -p debian/pegasus-wms/usr
	cp -a dist/pegasus/share debian/pegasus-wms/usr/
	rm -rf debian/pegasus-wms/usr/share/pegasus/visualize
	rm -rf debian/pegasus-wms/usr/share/pegasus/examples/simple-examples
	rm -rf debian/pegasus-wms/usr/share/pegasus/examples/glite-montage-pmc
	rm -rf debian/pegasus-wms/usr/share/pegasus/examples/grid-pegasus-mpi-cluster

	# documentation is in the -doc package
	rm -rf debian/pegasus-wms/usr/share/doc/pegasus

	# /usr/lib
	mkdir -p debian/pegasus-wms/usr
	cp -a dist/pegasus/lib debian/pegasus-wms/usr/

	# remove stuff we don't need
	rm -f debian/pegasus-wms/etc/pegasus/stampede*
	rm -rf debian/pegasus-wms/usr/lib/pegasus/externals/python/boto/tests

	# replace jar symlinks with relative symlinks
	(cd debian/pegasus-wms/usr/share/pegasus/java/ && \
	 for JAR in $(JARS); do \
	     rm $$JAR && \
	     ln -s ../../java/$$JAR ; \
	 done \
	)

	dh_installchangelogs -a
	dh_installdocs -a
	dh_installman -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a


binary: binary-indep binary-arch


clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp
	ant clean
	rm -f src/externals/._boto*
	rm -f src/tools/pegasus-keg/version.h
	rm -f lib/pegasus/python/Pegasus/DAX3.pyc
	rm -f lib/pegasus/perl/*.tmp
	rm -rf dist
	rm -rf debian/.pc
	dh_clean


%:
	echo "Unknown make target: $@"
	exit 1


.PHONY: build build-arch build-indep binary-indep binary-arch binary clean
